DCOPRef Class Reference

`#include <dcopref.h>`

## Public Types

enum | EventLoopFlag { NoEventLoop, UseEventLoop }

## Public Member Functions

| DCOPRef ()
| DCOPRef (const DCOPRef &ref)
| DCOPRef (const QCString &app, const QCString &obj="")
| DCOPRef (DCOPObject *object)
| DCOPRef (const QCString &app, const QCString &obj, const QCString &type)
bool | isNull () const
QCString | app () const
QCString | obj () const
QCString | object () const
QCString | type () const
DCOPRef & | operator= (const DCOPRef &)
void | setRef (const QCString &app, const QCString &obj="")
void | setRef (const QCString &app, const QCString &obj, const QCString &type)
void | clear ()
DCOPClient * | dcopClient () const
void | setDCOPClient (DCOPClient *client)
DCOPReply | call (const QCString &fun)
DCOPReply | callExt (const QCString &fun, EventLoopFlag useEventLoop=NoEventLoop, int timeout=-1)
template<class T1 >
DCOPReply | call (const QCString &fun, const T1 &t1)
template<class T1 >
DCOPReply | callExt (const QCString &fun, EventLoopFlag useEventLoop, int timeout, const T1 &t1)
template<class T1 , class T2 >
DCOPReply | call (const QCString &fun, const T1 &t1, const T2 &t2)
template<class T1 , class T2 >
DCOPReply | callExt (const QCString &fun, EventLoopFlag useEventLoop, int timeout, const T1 &t1, const T2 &t2)
template<class T1 , class T2 , class T3 >
DCOPReply | call (const QCString &fun, const T1 &t1, const T2 &t2, const T3 &t3)
template<class T1 , class T2 , class T3 >
DCOPReply | callExt (const QCString &fun, EventLoopFlag useEventLoop, int timeout, const T1 &t1, const T2 &t2, const T3 &t3)
template<class T1 , class T2 , class T3 , class T4 >
DCOPReply | call (const QCString &fun, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4)
template<class T1 , class T2 , class T3 , class T4 >
DCOPReply | callExt (const QCString &fun, EventLoopFlag useEventLoop, int timeout, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4)
template<class T1 , class T2 , class T3 , class T4 , class T5 >
DCOPReply | call (const QCString &fun, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4, const T5 &t5)
template<class T1 , class T2 , class T3 , class T4 , class T5 >
DCOPReply | callExt (const QCString &fun, EventLoopFlag useEventLoop, int timeout, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4, const T5 &t5)
template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 >
DCOPReply | call (const QCString &fun, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4, const T5 &t5, const T6 &t6)
template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 >
DCOPReply | callExt (const QCString &fun, EventLoopFlag useEventLoop, int timeout, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4, const T5 &t5, const T6 &t6)
template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 , class T7 >
DCOPReply | call (const QCString &fun, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4, const T5 &t5, const T6 &t6, const T7 &t7)
template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 , class T7 >
DCOPReply | callExt (const QCString &fun, EventLoopFlag useEventLoop, int timeout, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4, const T5 &t5, const T6 &t6, const T7 &t7)
template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 , class T7 , class T8 >
DCOPReply | call (const QCString &fun, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4, const T5 &t5, const T6 &t6, const T7 &t7, const T8 &t8)
template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 , class T7 , class T8 >
DCOPReply | callExt (const QCString &fun, EventLoopFlag useEventLoop, int timeout, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4, const T5 &t5, const T6 &t6, const T7 &t7, const T8 &t8)
bool | send (const QCString &fun)
template<class T1 >
bool | send (const QCString &fun, const T1 &t1)
template<class T1 , class T2 >
bool | send (const QCString &fun, const T1 &t1, const T2 &t2)
template<class T1 , class T2 , class T3 >
bool | send (const QCString &fun, const T1 &t1, const T2 &t2, const T3 &t3)
template<class T1 , class T2 , class T3 , class T4 >
bool | send (const QCString &fun, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4)
template<class T1 , class T2 , class T3 , class T4 , class T5 >
bool | send (const QCString &fun, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4, const T5 &t5)
template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 >
bool | send (const QCString &fun, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4, const T5 &t5, const T6 &t6)
template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 , class T7 >
bool | send (const QCString &fun, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4, const T5 &t5, const T6 &t6, const T7 &t7)
template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 , class T7 , class T8 >
bool | send (const QCString &fun, const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4, const T5 &t5, const T6 &t6, const T7 &t7, const T8 &t8)

## Detailed Description

A DCOPRef(erence) encapsulates a remote DCOP object as a triple <app,obj,type> where type is optional.

It allows for calling and passing DCOP objects.

A DCOP reference makes it possible to return references to other DCOP objects in a DCOP interface, for example in the method giveMeAnotherObject() in an interface like this:

class Example : public DCOPObject
{
K_DCOP
...
k_dcop:
DCOPRef giveMeAnotherObject();
int doSomething( QString, float, bool );
ASYNC pingMe( QCString message );
UserType userFunction( UserType );
};

In addition, the reference can operate as a comfortable generic stub to call remote DCOP objects in cases where no DCOPStub is available. The advantage of using DCOPRef instead of the low-level functions DCOPClient::call() and DCOPClient::send() are the nicer syntax and the implicit runtime error checking.

Say you want to call the method "doSomething" from the above interface on an object called "example" that lives in application "foo". Using DCOPRef, you would write

DCOPRef example( "foo", "example" );
int result = example.call( "doSomething", QString("Hello World"), (float)2.5, true );

If it is important for you to know whether the call succeeded or not, you can use the slightly more elaborate pattern:

DCOPRef example( "foo", "example" );
DCOPReply reply = example.call( "doSomething", QString("Hello World"), (float)2.5, true );
if ( reply.isValid() ) {
int result = reply;
// ...
}

Note that you must pass a QString for the first argument. If you use a regular char pointer, it will be converted to a QCString.

For curiosity, here is how you would achieve the exactly same functionality by using DCOPClient::call() directly:

QByteArray data, replyData;
QCString replyType;
QDataStream arg( data, IO_WriteOnly );
arg << QString("hello world" ), (float) 2.5 << true;
if ( DCOPClient::mainClient()->call( app, obj,
"doSomething(QString,float,bool)",
data, replyType, replyData ) ) {
if ( replyType == "int" ) {
int result;
QDataStream reply( replyData, IO_ReadOnly );
reply >> result;
// ...
}
}

As you might see from the code snippet, the DCOPRef has to "guess" the names of the datatypes of the arguments to construct a dcop call. This is done through global inline overloads of the dcopTypeName function, for example

inline const char* dcopTypeName( const QString& ) { return "QString"; }

If you use custom data types that do support QDataStream but have no corresponding dcopTypeName overload, you can either provide such an overload or use a DCOPArg wrapper that allows you to specify the type.

UserType userType;
DCOPReply reply = example.call( "userFunction", DCOPArg( userType, "UserType" ) );

Similar, when you retrieve such a data type, you can use an explicit call to DCOPReply::get():

UserType userType;
reply.get( userType, "UserType" );

The function send() works very similar to call(), only that it returns a simple bool on whether the signal could be sent or not:

if ( example.send( "pingMe", "message" ) == false )
qWarning("could not ping example" );

A DCOP reference operates on DCOPClient::mainClient(), unless you explicitly specify another client with setDCOPClient().

See also
  DCOPArg
  DCOPReply
  DCOPObject

Author
  Matthias Ettrich ettri.nosp@m.ch@k.nosp@m.de.or.nosp@m.g, Torben Weis weis@.nosp@m.kde..nosp@m.org

Definition at line 278 of file dcopref.h.

## Member Enumeration Documentation

enum DCOPRef::EventLoopFlag

Flag for allowing entering the event loop if the call blocks too long.

`NoEventLoop` disables entering the event loop. `UseEventLoop` allows entering the event loop while waiting for long blocking DCOP call, thus making the GUI repaint if needed, and possibly allowing also other code in the application to be executed.

See also
  DCOPClient::call()

Definition at line 403 of file dcopref.h.

## Constructor & Destructor Documentation

DCOPRef::DCOPRef | ( |  | ) |

Creates a null reference.

See also
  isNull()

Definition at line 105 of file dcopref.cpp.

DCOPRef::DCOPRef | ( | const DCOPRef & | ref | ) |

Copy constructor.

Definition at line 110 of file dcopref.cpp.

DCOPRef::DCOPRef | ( | const QCString & | app,
|  | const QCString & | obj = `""`
| ) |  |

Creates a reference for application `app` and object `obj`.

Parameters

  app | The name of an application as registered by the dcopserver.
  obj | The name of the dcop object.

Definition at line 125 of file dcopref.cpp.

DCOPRef::DCOPRef | ( | DCOPObject * | object | ) |

Creates a reference to an existing dcop object.

Parameters

  object | The dcop object to create the ref to.

Definition at line 118 of file dcopref.cpp.

DCOPRef::DCOPRef | ( | const QCString & | app,
|  | const QCString & | obj,
|  | const QCString & | type
| ) |  |

Creates a reference for application `app` and object `obj` with a specified type `type`.

Parameters

  app | The name of an application as registered by the dcopserver.
  obj | The name of the dcop object
  type | The object's type

Definition at line 130 of file dcopref.cpp.

## Member Function Documentation

QCString DCOPRef::app | ( |  | ) | const

Name of the application in which the object resides.

Returns
  the application's id. Can be null or empty if not set.

Definition at line 140 of file dcopref.cpp.

DCOPReply DCOPRef::call | ( | const QCString & | fun | ) |

inline

Calls the function `fun` on the object referenced by this reference.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  send()
  DCOPArg

Since
  3.1

Definition at line 417 of file dcopref.h.

template<class T1 >

DCOPReply DCOPRef::call | ( | const QCString & | fun,
|  | const T1 & | t1
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  send()
  DCOPArg

Since
  3.1

Definition at line 457 of file dcopref.h.

template<class T1 , class T2 >

DCOPReply DCOPRef::call | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  send()
  DCOPArg

Since
  3.1

Definition at line 513 of file dcopref.h.

template<class T1 , class T2 , class T3 >

DCOPReply DCOPRef::call | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  send()
  DCOPArg

Since
  3.1

Definition at line 578 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 >

DCOPReply DCOPRef::call | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  send()
  DCOPArg

Since
  3.1

Definition at line 651 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 , class T5 >

DCOPReply DCOPRef::call | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4,
|  | const T5 & | t5
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.
  t5 | the fifth argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  send()
  DCOPArg

Since
  3.1

Definition at line 732 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 >

DCOPReply DCOPRef::call | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4,
|  | const T5 & | t5,
|  | const T6 & | t6
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.
  t5 | the fifth argument of the function. This can be a supported base type or a DCOPArg object.
  t6 | the sixth argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  send()
  DCOPArg

Since
  3.1

Definition at line 821 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 , class T7 >

DCOPReply DCOPRef::call | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4,
|  | const T5 & | t5,
|  | const T6 & | t6,
|  | const T7 & | t7
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.
  t5 | the fifth argument of the function. This can be a supported base type or a DCOPArg object.
  t6 | the sixth argument of the function. This can be a supported base type or a DCOPArg object.
  t7 | the seventh argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  send()
  DCOPArg

Since
  3.1

Definition at line 917 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 , class T7 , class T8 >

DCOPReply DCOPRef::call | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4,
|  | const T5 & | t5,
|  | const T6 & | t6,
|  | const T7 & | t7,
|  | const T8 & | t8
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.
  t5 | the fifth argument of the function. This can be a supported base type or a DCOPArg object.
  t6 | the sixth argument of the function. This can be a supported base type or a DCOPArg object.
  t7 | the seventh argument of the function. This can be a supported base type or a DCOPArg object.
  t8 | the eigth argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  send()
  DCOPArg

Since
  3.1

Definition at line 1022 of file dcopref.h.

DCOPReply DCOPRef::callExt | ( | const QCString & | fun,
|  | EventLoopFlag | useEventLoop = `NoEventLoop`,
|  | int | timeout = `-1`
| ) |  |

inline

Like call(), with additional arguments allowing entering the event loop and specifying timeout.

Parameters

  useEventLoop | if UseEventLoop, the event loop will be started when the call blocks too long
  timeout | timeout for the call in miliseconds, or -1 for no timeout
  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments

Since
  3.2

Definition at line 435 of file dcopref.h.

template<class T1 >

DCOPReply DCOPRef::callExt | ( | const QCString & | fun,
|  | EventLoopFlag | useEventLoop,
|  | int | timeout,
|  | const T1 & | t1
| ) |  |

inline

Like call(), with additional arguments allowing entering the event loop and specifying timeout.

Parameters

  useEventLoop | if UseEventLoop, the event loop will be started when the call blocks too long
  timeout | timeout for the call in miliseconds, or -1 for no timeout
  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.

Since
  3.2

Definition at line 483 of file dcopref.h.

template<class T1 , class T2 >

DCOPReply DCOPRef::callExt | ( | const QCString & | fun,
|  | EventLoopFlag | useEventLoop,
|  | int | timeout,
|  | const T1 & | t1,
|  | const T2 & | t2
| ) |  |

inline

Like call(), with additional arguments allowing entering the event loop and specifying timeout.

Parameters

  useEventLoop | if UseEventLoop, the event loop will be started when the call blocks too long
  timeout | timeout for the call in miliseconds, or -1 for no timeout
  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.

Since
  3.2

Definition at line 544 of file dcopref.h.

template<class T1 , class T2 , class T3 >

DCOPReply DCOPRef::callExt | ( | const QCString & | fun,
|  | EventLoopFlag | useEventLoop,
|  | int | timeout,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3
| ) |  |

inline

Like call(), with additional arguments allowing entering the event loop and specifying timeout.

Parameters

  useEventLoop | if UseEventLoop, the event loop will be started when the call blocks too long
  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  timeout | timeout for the call in miliseconds, or -1 for no timeout

Since
  3.2

Definition at line 613 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 >

DCOPReply DCOPRef::callExt | ( | const QCString & | fun,
|  | EventLoopFlag | useEventLoop,
|  | int | timeout,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4
| ) |  |

inline

Like call(), with additional arguments allowing entering the event loop and specifying timeout.

Parameters

  useEventLoop | if UseEventLoop, the event loop will be started when the call blocks too long
  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  timeout | timeout for the call in miliseconds, or -1 for no timeout
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.

Since
  3.2

Definition at line 690 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 , class T5 >

DCOPReply DCOPRef::callExt | ( | const QCString & | fun,
|  | EventLoopFlag | useEventLoop,
|  | int | timeout,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4,
|  | const T5 & | t5
| ) |  |

inline

Like call(), with additional arguments allowing entering the event loop and specifying timeout.

Parameters

  useEventLoop | if UseEventLoop, the event loop will be started when the call blocks too long
  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  timeout | timeout for the call in miliseconds, or -1 for no timeout
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.
  t5 | the fifth argument of the function. This can be a supported base type or a DCOPArg object.

Since
  3.2

Definition at line 775 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 >

DCOPReply DCOPRef::callExt | ( | const QCString & | fun,
|  | EventLoopFlag | useEventLoop,
|  | int | timeout,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4,
|  | const T5 & | t5,
|  | const T6 & | t6
| ) |  |

inline

Like call(), with additional arguments allowing entering the event loop and specifying timeout.

Parameters

  useEventLoop | if UseEventLoop, the event loop will be started when the call blocks too long
  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  timeout | timeout for the call in miliseconds, or -1 for no timeout
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.
  t5 | the fifth argument of the function. This can be a supported base type or a DCOPArg object.
  t6 | the sixth argument of the function. This can be a supported base type or a DCOPArg object.

Since
  3.2

Definition at line 868 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 , class T7 >

DCOPReply DCOPRef::callExt | ( | const QCString & | fun,
|  | EventLoopFlag | useEventLoop,
|  | int | timeout,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4,
|  | const T5 & | t5,
|  | const T6 & | t6,
|  | const T7 & | t7
| ) |  |

inline

Like call(), with additional arguments allowing entering the event loop and specifying timeout.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  useEventLoop | if UseEventLoop, the event loop will be started when the call blocks too long
  timeout | timeout for the call in miliseconds, or -1 for no timeout
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.
  t5 | the fifth argument of the function. This can be a supported base type or a DCOPArg object.
  t6 | the sixth argument of the function. This can be a supported base type or a DCOPArg object.
  t7 | the seventh argument of the function. This can be a supported base type or a DCOPArg object.

Since
  3.2

Definition at line 968 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 , class T7 , class T8 >

DCOPReply DCOPRef::callExt | ( | const QCString & | fun,
|  | EventLoopFlag | useEventLoop,
|  | int | timeout,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4,
|  | const T5 & | t5,
|  | const T6 & | t6,
|  | const T7 & | t7,
|  | const T8 & | t8
| ) |  |

inline

Like call(), with additional arguments allowing entering the event loop and specifying timeout.

Parameters

  useEventLoop | if UseEventLoop, the event loop will be started when the call blocks too long
  timeout | timeout for the call in miliseconds, or -1 for no timeout
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.
  t5 | the fifth argument of the function. This can be a supported base type or a DCOPArg object.
  t6 | the sixth argument of the function. This can be a supported base type or a DCOPArg object.
  t7 | the seventh argument of the function. This can be a supported base type or a DCOPArg object.
  t8 | the eigth argument of the function. This can be a supported base type or a DCOPArg object.
  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments

Since
  3.2

Definition at line 1077 of file dcopref.h.

void DCOPRef::clear | ( |  | ) |

Makes this a null reference.

See also
  isNull()

Definition at line 194 of file dcopref.cpp.

DCOPClient * DCOPRef::dcopClient | ( |  | ) | const

Returns the dcop client the reference operates on.

If no client has been set, this is the DCOPClient::mainClient().

Returns
  the DCOPClient of this object

Since
  3.1

Definition at line 166 of file dcopref.cpp.

bool DCOPRef::isNull | ( |  | ) | const

Tests whether this is a null reference.

Returns
  true if this object is a null reference

See also
  clear()

Definition at line 135 of file dcopref.cpp.

QCString DCOPRef::obj | ( |  | ) | const

Object ID of the referenced object.

Returns
  the id of the referenced object. Can be null or empty if not set.

Since
  3.1

Definition at line 145 of file dcopref.cpp.

QCString DCOPRef::object | ( |  | ) | const

Deprecated:

Definition at line 150 of file dcopref.cpp.

DCOPRef & DCOPRef::operator= | ( | const DCOPRef & | ref | ) |

Assignment operator.

Copies the references data.

Definition at line 171 of file dcopref.cpp.

bool DCOPRef::send | ( | const QCString & | fun | ) |

inline

Calls the function `fun` on the object referenced by this reference.

Unlike call() this method does not expect a return value.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  call()

Since
  3.1

Definition at line 1116 of file dcopref.h.

template<class T1 >

bool DCOPRef::send | ( | const QCString & | fun,
|  | const T1 & | t1
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Unlike call() this method does not expect a return value.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  call()
  DCOPArg

Since
  3.1

Definition at line 1138 of file dcopref.h.

template<class T1 , class T2 >

bool DCOPRef::send | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Unlike call() this method does not expect a return value.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  call()
  DCOPArg

Since
  3.1

Definition at line 1166 of file dcopref.h.

template<class T1 , class T2 , class T3 >

bool DCOPRef::send | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Unlike call() this method does not expect a return value.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  call()
  DCOPArg

Since
  3.1

Definition at line 1199 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 >

bool DCOPRef::send | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Unlike call() this method does not expect a return value.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  call()
  DCOPArg

Since
  3.1

Definition at line 1236 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 , class T5 >

bool DCOPRef::send | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4,
|  | const T5 & | t5
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Unlike call() this method does not expect a return value.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.
  t5 | the fifth argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  call()
  DCOPArg

Since
  3.1

Definition at line 1277 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 >

bool DCOPRef::send | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4,
|  | const T5 & | t5,
|  | const T6 & | t6
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Unlike call() this method does not expect a return value.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.
  t5 | the fifth argument of the function. This can be a supported base type or a DCOPArg object.
  t6 | the sixth argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  call()
  DCOPArg

Since
  3.1

Definition at line 1322 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 , class T7 >

bool DCOPRef::send | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4,
|  | const T5 & | t5,
|  | const T6 & | t6,
|  | const T7 & | t7
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Unlike call() this method does not expect a return value.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.
  t5 | the fifth argument of the function. This can be a supported base type or a DCOPArg object.
  t6 | the sixth argument of the function. This can be a supported base type or a DCOPArg object.
  t7 | the seventh argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  call()
  DCOPArg

Since
  3.1

Definition at line 1371 of file dcopref.h.

template<class T1 , class T2 , class T3 , class T4 , class T5 , class T6 , class T7 , class T8 >

bool DCOPRef::send | ( | const QCString & | fun,
|  | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4,
|  | const T5 & | t5,
|  | const T6 & | t6,
|  | const T7 & | t7,
|  | const T8 & | t8
| ) |  |

inline

Calls the function `fun` on the object referenced by this reference.

Unlike call() this method does not expect a return value.

Parameters

  fun | the name of the DCOP function. This can be either the full function signature (e.g. "setName(QString)") or only the function's name (e.g. "setName"). In the latter case the exact signature will be guessed from the arguments
  t1 | the first argument of the function. This can be a supported base type or a DCOPArg object.
  t2 | the second argument of the function. This can be a supported base type or a DCOPArg object.
  t3 | the third argument of the function. This can be a supported base type or a DCOPArg object.
  t4 | the fourth argument of the function. This can be a supported base type or a DCOPArg object.
  t5 | the fifth argument of the function. This can be a supported base type or a DCOPArg object.
  t6 | the sixth argument of the function. This can be a supported base type or a DCOPArg object.
  t7 | the seventh argument of the function. This can be a supported base type or a DCOPArg object.
  t8 | the eigth argument of the function. This can be a supported base type or a DCOPArg object.

Returns
  the DCOPReply object. Is invalid ( DCOPReply::isValid()) when an error occurred.

See also
  call()
  DCOPArg

Since
  3.1

Definition at line 1424 of file dcopref.h.

void DCOPRef::setDCOPClient | ( | DCOPClient * | client | ) |

Sets a specific dcop client for this reference.

Otherwise DCOPClient::mainClient() is used.

Parameters

  client | the new DCOPClient of this object

Since
  3.1

Definition at line 161 of file dcopref.cpp.

void DCOPRef::setRef | ( | const QCString & | app,
|  | const QCString & | obj = `""`
| ) |  |

Changes the referenced object.

Resets the type to unknown (null). The type is not needed for call() and send().

Parameters

  app | the application id.
  obj | the object id

Definition at line 180 of file dcopref.cpp.

void DCOPRef::setRef | ( | const QCString & | app,
|  | const QCString & | obj,
|  | const QCString & | type
| ) |  |

Changes the referenced object.

Parameters

  app | the application id.
  obj | the object id
  type | the object's type

Definition at line 187 of file dcopref.cpp.

QCString DCOPRef::type | ( |  | ) | const

Type of the referenced object.

May be null (i.e. unknown).

Returns
  the type of the referenced object, or null if unknown

Definition at line 156 of file dcopref.cpp.

The documentation for this class was generated from the following files:

- dcopref.h
- dcopref.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys